/* ------------------------------------------------------------ */
/* -- Authors:						     -- */
/* --	Prasad Deshpande				     -- */
/* --	Avinash Sodani					     -- */
/* --							     -- */
/* --	Copyright (c) 1995  Computer Sciences Department     -- */
/* --	University of Wisconsin, Madison		     -- */
/* --	All rights reserved				     --	*/
/* ------------------------------------------------------------ */

#include <rpc/rpc.h>
#define _BOOL_H_

#include <StubPreamble.h>
#include <javaString.h>

#include "sockaddr_in.h"
#include "rpcinterface.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <assert.h>
#include "proctab.h"

extern XDR * Xdrp;

/* currently only 1 server function can be registered. To be able to register
   more functions, just define cfunc1, cfunc2, .. so on. Similarly xdr_in1,..
   and xdr_out1,... cfunci will use ProcTab[i]..    
*/

char *cfunc0(char *ignoreinput)
{
 long retval;

 printf("cfunc 0 called\n");
 retval=execute_java_dynamic_method (0,
		  (HObject *)ProcTab[0].procname,
		 "func","(Ljava/lang/Object;Ljava/lang/Object;)Z",
		      (struct Hjava_lang_Object *)ProcTab[0].Inobj,
		      (struct Hjava_lang_Object *)ProcTab[0].Outobj);

 return (char *)ProcTab[0].Outobj;
}

bool_t xdr_in0(XDR *xdrs, char *Ignorein)
{
 Xdrp = xdrs;

 printf("xdr_in0 called\n");
 return execute_java_dynamic_method(0, (HObject *)ProcTab[0].inproc, "xdr_func",
		 "(Ljava/lang/Object;)Z", 
		 (struct Hjava_lang_Object *)ProcTab[0].Inobj);
 
}

bool_t xdr_out0(XDR *xdrs, char *out)
{
  Xdrp = xdrs;

 printf("xdr_out0 called\n");
  return execute_java_dynamic_method(0, (HObject *)ProcTab[0].outproc, "xdr_func",
			"(Ljava/lang/Object;)Z", 
			(struct Hjava_lang_Object *)out);
}
