/* ------------------------------------------------------------ */
/* -- Authors:						     -- */
/* --	Prasad Deshpande				     -- */
/* --	Avinash Sodani					     -- */
/* --							     -- */
/* --	Copyright (c) 1995  Computer Sciences Department     -- */
/* --	University of Wisconsin, Madison		     -- */
/* --	All rights reserved				     --	*/
/* ------------------------------------------------------------ */

 public class xdrInt {

	static native boolean xdr_string(String s[], int maxlength);

	static native boolean xdr_byte(byte val[]);

	static native boolean xdr_short(short val[]);

	static native boolean xdr_int(int val[]);

	static native boolean xdr_long(long val[]);

	static native boolean xdr_float(float val[]);

	static native boolean xdr_double(double val[]);

	static native boolean xdr_char(char val[]);

	static native boolean xdr_boolean(boolean val[]);

	static boolean xdr_bytes(byte[] val[], int size[], int maxsize)
	{
		boolean status;
		byte[] bytearr;
		if ((val[0] != null) && val[0].length >= maxsize)
			bytearr = val[0];
		else
		{
			bytearr = new byte[maxsize];
			if (val[0] != null)
				for (int i=0; i<val[0].length;i++)
					bytearr[i] = val[0][i];
		}

		status = xdr_byte_native(bytearr, size, maxsize);
		val[0] = bytearr;
		return status;
	};	

	static native boolean xdr_byte_native(byte[] bytearr, int[] size, int maxsize);

	static boolean xdr_opaque(byte[] val)
	{
		if (val == null) return true;
		return xdr_opaque_native(val, val.length);
	};

	static native boolean xdr_opaque_native(byte[] val, int size);

	static boolean xdr_pointer(Object val[],  func xfn, objfunc ofn)
	{
		boolean b[] = new boolean[1];
		boolean status;
		Object obj=null;

		if (val[0] != null)
		{
			b[0] = true;
			obj = val[0];
		}
		else
			b[0]= false;
		if (!xdr_boolean(b)) return false;
		status = true;
		if (b[0])
		{
			if (obj == null)
				obj =  ofn.newobj();
			status = xfn.xdr_func(obj);
			val[0] = obj;
		}
		return status;
	}


	static boolean xdr_array(Object[] val[], int[] size, int maxsize, func xfn, objfunc ofn)
	{
		int i;

		xdr_int(size);
		if (size[0] > maxsize) 
			return false;
			
		if (val[0] == null)
			val[0] = new Object[size[0]];

		for (i=0; i<size[0]; i++)
		{
			if (val[0][i] == null)
				val[0][i] = ofn.newobj();
			if (!xfn.xdr_func(val[0][i]))
				return false;
		}
		return true;
	};

	boolean xdr_vector(Object[] val,  func xfn)
	{
		int i;

		for (i=0; i<val.length; i++)
			if (!xfn.xdr_func(val[i]))
				return false;
		return true;
	};		
		

	static {
                            	System.loadLibrary("xrpc");
	};
}
