/* ------------------------------------------------------------ */
/* -- Authors:						     -- */
/* --	Prasad Deshpande				     -- */
/* --	Avinash Sodani					     -- */
/* --							     -- */
/* --	Copyright (c) 1995  Computer Sciences Department     -- */
/* --	University of Wisconsin, Madison		     -- */
/* --	All rights reserved				     --	*/
/* ------------------------------------------------------------ */

#include <rpc/rpc.h>
#define _BOOL_H_

#include <StubPreamble.h>
#include "xdrInt.h"

#include <assert.h>

extern XDR* Xdrp;

/*boolean*/ long xdrInt_xdr_string(struct HxdrInt *this, HArrayOfString* Strp, 
			long maxlength)
{
	long stat;
	Hjava_lang_String * strhandle;
	char *buf;

	if (Xdrp->x_op == XDR_FREE) return TRUE;
	buf = malloc(maxlength+1);
	assert(buf);
	
	if (Xdrp->x_op == XDR_ENCODE)
	{
		strhandle = unhand(Strp)->body[0];
		javaString2CString(strhandle, buf, maxlength);
	}
	stat = xdr_string(Xdrp, &buf, maxlength);
	printf("In C xdr_string :%s\n", buf);
	if (Xdrp->x_op == XDR_DECODE)
	{
		strhandle = makeJavaString(buf, maxlength);
		unhand(Strp)->body[0] = strhandle;
	}
	if (buf) free(buf);	
	return stat;
}

/*boolean*/ long xdrInt_xdr_byte(struct HxdrInt *this, struct HArrayOfByte*  Arr)
{
	return  xdr_char(Xdrp, unhand(Arr)->body);
}

/*boolean*/ long xdrInt_xdr_short(struct HxdrInt *this, struct HArrayOfShort*  Arr)
{
	return  xdr_short(Xdrp, unhand(Arr)->body);
}

/*boolean*/ long xdrInt_xdr_int(struct HxdrInt *this, struct HArrayOfInt* Arr )
{
	return  xdr_long(Xdrp, unhand(Arr)->body);
}

/*boolean*/ long xdrInt_xdr_long(struct HxdrInt *this, struct HArrayOfLong*  Arr)
{
	return  xdr_longlong_t(Xdrp, unhand(Arr)->body);
}

/*boolean*/ long xdrInt_xdr_float(struct HxdrInt *this, struct HArrayOfFloat*  Arr)
{
	return  xdr_float(Xdrp, unhand(Arr)->body);
}

/*boolean*/ long xdrInt_xdr_double(struct HxdrInt *this, struct HArrayOfDouble*  Arr)
{
	return  xdr_double(Xdrp, unhand(Arr)->body);
}

/*boolean*/ long xdrInt_xdr_char(struct HxdrInt *this, struct HArrayOfChar*  Arr)
{
	char ch;
	int stat;

	ch = unhand(Arr)->body[0];   /* change from unicode to C char */
	stat =  xdr_char(Xdrp, &ch);
	unhand(Arr)->body[0] = ch;
	return stat;
}

/*boolean*/ long xdrInt_xdr_boolean(struct HxdrInt *this, struct HArrayOfInt*  Arr)
{
                    long status;
	int tmp = *(char *)(unhand(Arr)->body);
	status=  xdr_bool(Xdrp, (bool_t *)&tmp);
	*(char *)(unhand(Arr)->body) = tmp;
	return status;
}

/*boolean*/ long xdrInt_xdr_byte_native(struct HxdrInt *this,HArrayOfByte *Arr,
					HArrayOfInt *size,long maxsize)
{
                   char *body = unhand(Arr)->body;
                   return xdr_bytes(Xdrp, &body, (u_int *)unhand(size)->body, maxsize);
}

/*boolean*/ long xdrInt_xdr_opaque_native(struct HxdrInt *this,HArrayOfByte *Arr, long size)
{
                  return xdr_opaque(Xdrp, unhand(Arr)->body, size);
}


